update problem 9.2